searchNodes=[{"doc":"LvStates help LiveView craft with useful state-management utils. Currently there is one available feature: LvStates.WithSearch","ref":"LvStates.html","title":"LvStates","type":"module"},{"doc":"","ref":"LvStates.Utils.html","title":"LvStates.Utils","type":"module"},{"doc":"","ref":"LvStates.Utils.html#key_atomize/1","title":"LvStates.Utils.key_atomize/1","type":"function"},{"doc":"","ref":"LvStates.Utils.html#process_options/2","title":"LvStates.Utils.process_options/2","type":"function"},{"doc":"","ref":"LvStates.Utils.html#socket_get_field/3","title":"LvStates.Utils.socket_get_field/3","type":"function"},{"doc":"","ref":"LvStates.Utils.html#socket_set_field/4","title":"LvStates.Utils.socket_set_field/4","type":"function"},{"doc":"LvStates.WithFilter stores any number of multi-value or single-value state keys that you choose inside the :lvs_filters namespace. It is useful when we want to filter our data based on a fixed set of values/categories. Using the LvStates.WithFilter macro will have two consequences for our LiveView.Socket : It populates :lvs_filters with a map for each of your filterable keys. A few event handles are generated to manipulate the state of your filters. # In case of :multiple, it adds the value to the specified filter. In case of :single filter, it overwrites the current value def handle_event ( &quot;lvs-filter-set&quot; , %{ &quot;field&quot; =&gt; field , &quot;value&quot; =&gt; value } , % Socket { } = socket ) do # Removes the value of a particular filter from the state def handle_event ( &quot;lvs-filter-remove&quot; , %{ &quot;field&quot; =&gt; field , &quot;value&quot; =&gt; value } , % Socket { } = socket ) do # Clears all values from a particular filter, both for :single and :multiple filters. def handle_event ( &quot;lvs-filter-clear&quot; , %{ &quot;field&quot; =&gt; field } , % Socket { } = socket ) do # Clears all values from all filters under the :lvs_filters namespace def handle_event ( &quot;lvs-filter-clear-all&quot; , _ , % Socket { } = socket ) do And lastly an indirect consequence is that LvStates.WithSearch assumes that our LiveView implements the following method: def fetch ( % LiveView.Socket { } ) Note : if the assumed fetch/1 function is not implemented the functionality will not work as expected. Examples defmodule CarInventory do use LvStates.WithSearch , [ :model ] end","ref":"LvStates.WithFilter.html","title":"LvStates.WithFilter","type":"module"},{"doc":"","ref":"LvStates.WithFilter.html#multiple_field_initial_state/0","title":"LvStates.WithFilter.multiple_field_initial_state/0","type":"function"},{"doc":"LvStates.WithSearch adds a :search subset of state to the main LiveView.Socket . It is useful in situations where we want our application to query our data most typically stemming from a client search input. Using the LvStates.WithSearch macro will have two consequences for our LiveView.Socket : It is populated with a :search field containing %{searching: false, query: nil} . A new event handler is generated: def handle_event ( &quot;search-model&quot; , %{ &quot;query&quot; =&gt; query } , socket ) And lastly an indirect consequence is that LvStates.WithSearch assumes that our LiveView implements the following method: def fetch ( % LiveView.Socket { } ) Note : if the assumed fetch/1 function is not implemented the functionality will not work as expected. Examples defmodule CarInventory do use LvStates.WithSearch , [ :model ] end","ref":"LvStates.WithSearch.html","title":"LvStates.WithSearch","type":"module"},{"doc":"Lv-States lv-states (short for LiveView States) provides a handful of state management helpers for Phoenix LiveView Sockets with the aim of simplifying common needs of client &lt;&gt; server communication present in interactive applications. See it in action at https://lv-states.fly.dev Documentation Read the full documentation at https://hexdocs.pm/lv_states/ Installation def deps do [ { :lv_states , &quot;~&gt; 0.1.1&quot; } ] end","ref":"readme.html","title":"Lv-States","type":"extras"},{"doc":"Useful for those situations in which a search is present in the UI. Usage defmodule CarInventory do use LvStates.WithSearch , [ :model ] #...rest of functions end You can now comfortably point your client events to the new event handler, Eg. &lt;form phx-change=&quot;search-model&quot;&gt; &lt;input type=&quot;text&quot; name=&quot;query&quot; phx-debounce=&quot;300&quot; value=&quot;&lt;%= @search.model.query %&gt;&quot; placeholder=&quot;Insert the model name to search&quot;&gt; &lt;/form&gt; For a full example please see the source of the demo","ref":"readme.html#withsearch","title":"Lv-States - WithSearch","type":"extras"},{"doc":"Useful for multi-value fields. Usage defmodule CarInventory do use LvStates.WithFilter , [ brand : :multiple ] #...rest of functions end Send events from a collection of options to the event handler like this: &lt;%= for b &lt;- @brands do %&gt; &lt;div phx-click=&quot;lvs-filter-set&quot; phx-value-field=&quot;brand&quot; phx-value-value=&quot;&lt;%= b %&gt;&quot; &gt; &lt;%= b %&gt; &lt;/div&gt; &lt;% end %&gt; %&gt; For a full example please see the source of the demo","ref":"readme.html#withfilter","title":"Lv-States - WithFilter","type":"extras"},{"doc":"Migrate phoenix demo app to esbuild Use Utils.socket_set_field for WithSearch helper Create test utils functions to obtain useful structs Check that values added are binary not nil Compilation-time check that &quot;fetch&quot; or dynamic fetcher function exists in the host module","ref":"readme.html#todo","title":"Lv-States - TODO","type":"extras"},{"doc":"Migrate phoenix demo app to esbuild Use Utils.socket_set_field for WithSearch helper Create test utils functions to obtain useful structs Check that values added are binary not nil Compilation-time check that &quot;fetch&quot; or dynamic fetcher function exists in the host module","ref":"readme.html#todo","title":"Lv-States - TODO","type":"extras"}]